/**
 * @name array-group-str-omit-num-char
 * @fileoverview Groups array of strings by omitting number characters
 * @version 6.0.6
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/array-group-str-omit-num-char/}
 */

"use strict";var arrayGroupStrOmitNumChar=(()=>{var m=Object.defineProperty;var j=Object.getOwnPropertyDescriptor;var S=Object.getOwnPropertyNames,b=Object.getOwnPropertySymbols;var w=Object.prototype.hasOwnProperty,x=Object.prototype.propertyIsEnumerable;var $=(r,n,i)=>n in r?m(r,n,{enumerable:!0,configurable:!0,writable:!0,value:i}):r[n]=i,g=(r,n)=>{for(var i in n||(n={}))w.call(n,i)&&$(r,i,n[i]);if(b)for(var i of b(n))x.call(n,i)&&$(r,i,n[i]);return r};var N=(r,n)=>{for(var i in n)m(r,i,{get:n[i],enumerable:!0})},I=(r,n,i,t)=>{if(n&&typeof n=="object"||typeof n=="function")for(let a of S(n))!w.call(r,a)&&a!==i&&m(r,a,{get:()=>n[a],enumerable:!(t=j(n,a))||t.enumerable});return r};var F=r=>I(m({},"__esModule",{value:!0}),r);var B={};N(B,{defaults:()=>R,groupStr:()=>P,version:()=>H});var _={strictlyTwoElementsInRangeArrays:!1,progressFn:null};function f(r,n){if(!Array.isArray(r)||!r.length)return r;let i=g(g({},_),n),t,a;if(i.strictlyTwoElementsInRangeArrays&&!r.every((o,u)=>!Array.isArray(o)||o.length!==2?(t=u,a=o.length,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${t}th range (${JSON.stringify(r[t],null,4)}) has not two but ${a} elements!`);if(!r.every((o,u)=>!Array.isArray(o)||!Number.isInteger(o[0])||o[0]<0||!Number.isInteger(o[1])||o[1]<0?(t=u,!1):!0))throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${t}th range (${JSON.stringify(r[t],null,4)}) does not consist of only natural numbers!`);let s=r.length**2,c=0;return Array.from(r).sort((o,u)=>(i.progressFn&&(c+=1,i.progressFn(Math.floor(c*100/s))),o[0]===u[0]?o[1]<u[1]?-1:o[1]>u[1]?1:0:o[0]<u[0]?-1:1))}var O={mergeType:1,progressFn:null,joinRangesThatTouchEdges:!0};function A(r,n){function i(e){return!!e&&typeof e=="object"&&!Array.isArray(e)}if(!Array.isArray(r)||!r.length)return null;let t;if(n)if(i(n)){if(t=g(g({},O),n),t.progressFn&&i(t.progressFn)&&!Object.keys(t.progressFn).length)t.progressFn=null;else if(t.progressFn&&typeof t.progressFn!="function")throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof t.progressFn}", equal to ${JSON.stringify(t.progressFn,null,4)}`);if(![1,2,"1","2"].includes(t.mergeType))throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof t.mergeType}", equal to ${JSON.stringify(t.mergeType,null,4)}`);if(typeof t.joinRangesThatTouchEdges!="boolean")throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof t.joinRangesThatTouchEdges}", equal to ${JSON.stringify(t.joinRangesThatTouchEdges,null,4)}`)}else throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(n,null,4)} (type ${typeof n})`);else t=g({},O);let a=r.filter(e=>Array.isArray(e)).map(e=>[...e]).filter(e=>e[2]!==void 0||e[0]!==e[1]),s,c,o;t.progressFn?s=f(a,{progressFn:e=>{o=Math.floor(e/5),o!==c&&(c=o,t.progressFn(o))}}):s=f(a);let u=s.length-1;for(let e=u;e>0;e--)t.progressFn&&(o=Math.floor((1-e/u)*78)+21,o!==c&&o>c&&(c=o,t.progressFn(o))),(s[e][0]<=s[e-1][0]||!t.joinRangesThatTouchEdges&&s[e][0]<s[e-1][1]||t.joinRangesThatTouchEdges&&s[e][0]<=s[e-1][1])&&(s[e-1][0]=Math.min(s[e][0],s[e-1][0]),s[e-1][1]=Math.max(s[e][1],s[e-1][1]),s[e][2]!==void 0&&(s[e-1][0]>=s[e][0]||s[e-1][1]<=s[e][1])&&s[e-1][2]!==null&&(s[e][2]===null&&s[e-1][2]!==null?s[e-1][2]=null:s[e-1][2]!=null?+t.mergeType==2&&s[e-1][0]===s[e][0]?s[e-1][2]=s[e][2]:s[e-1][2]+=s[e][2]:s[e-1][2]=s[e][2]),s.splice(e,1),e=s.length);return s.length?s:null}var V=!0,y="Invariant failed";function W(r,n){if(!r){if(V)throw new Error(y);var i=typeof n=="function"?n():n,t=i?"".concat(y,": ").concat(i):y;throw new Error(t)}}function E(r,n,i){let t=0,a=0;if(arguments.length===0)throw new Error("ranges-apply: [THROW_ID_01] inputs missing!");if(typeof r!="string")throw new TypeError(`ranges-apply: [THROW_ID_02] first input argument must be a string! Currently it's: ${typeof r}, equal to: ${JSON.stringify(r,null,4)}`);if(n&&!Array.isArray(n))throw new TypeError(`ranges-apply: [THROW_ID_03] second input argument must be an array (or null)! Currently it's: ${typeof n}, equal to: ${JSON.stringify(n,null,4)}`);if(i&&typeof i!="function")throw new TypeError(`ranges-apply: [THROW_ID_04] the third input argument must be a function (or falsey)! Currently it's: ${typeof i}, equal to: ${JSON.stringify(i,null,4)}`);if(!n||!n.filter(l=>l).length)return r;let s;Array.isArray(n)&&Number.isInteger(n[0])&&Number.isInteger(n[1])?s=[Array.from(n)]:s=Array.from(n);let c=s.length,o=0;s.filter(l=>l).forEach((l,p)=>{if(i&&(t=Math.floor(o/c*10),t!==a&&(a=t,i(t))),!Array.isArray(l))throw new TypeError(`ranges-apply: [THROW_ID_05] ranges array, second input arg., has ${p}th element not an array: ${JSON.stringify(l,null,4)}, which is ${typeof l}`);if(!Number.isInteger(l[0])){if(!Number.isInteger(+l[0])||+l[0]<0)throw new TypeError(`ranges-apply: [THROW_ID_06] ranges array, second input arg. has ${p}th element, array ${JSON.stringify(l,null,0)}. Its first element is not an integer, string index, but ${typeof l[0]}, equal to: ${JSON.stringify(l[0],null,4)}.`);s[p][0]=+s[p][0]}if(!Number.isInteger(l[1])){if(!Number.isInteger(+l[1])||+l[1]<0)throw new TypeError(`ranges-apply: [THROW_ID_07] ranges array, second input arg. has ${p}th element, array ${JSON.stringify(l,null,0)}. Its second element is not an integer, string index, but ${typeof l[1]}, equal to: ${JSON.stringify(l[1],null,4)}.`);s[p][1]=+s[p][1]}o+=1});let u=A(s,{progressFn:l=>{i&&(t=10+Math.floor(l/10),t!==a&&(a=t,i(t)))}});W(u);let e=u.length;if(e>0){let l=r.slice(u[e-1][1]);r=u.reduce((p,L,d,h)=>{i&&(t=20+Math.floor(d/e*80),t!==a&&(a=t,i(t)));let D=d===0?0:h[d-1][1],C=h[d][0];return`${p}${r.slice(D,C)}${h[d][2]||""}`},""),r+=l}return r}function J(r){if(r==null||typeof r!="object")return!1;let n=Object.getPrototypeOf(r);return n!==null&&n!==Object.prototype&&Object.getPrototypeOf(n)!==null?!1:!(Symbol.iterator in r)&&!(Symbol.toStringTag in r)}function M(r){return typeof r=="string"}function T(r,n){return J(r)&&M(n)&&Object.prototype.hasOwnProperty.call(r,n)}var v="6.0.6";var H=v,R={wildcard:"*",dedupePlease:!0};function P(r,n){if(!Array.isArray(r))return r;if(!r.length)return{};let i=g(g({},R),n),t=i.dedupePlease?[...new Set(r)]:Array.from(r),a={};for(let c=0,o=t.length;c<o;c++){let u=t[c].match(/\d+/gm);if(!u)a[t[c]]={count:1};else{let e=t[c].replace(/\d+/gm,i.wildcard);T(a,e)?(u.forEach((l,p)=>{a[e].elementsWhichWeCanReplaceWithWildcards[p]&&l!==a[e].elementsWhichWeCanReplaceWithWildcards[p]&&(a[e].elementsWhichWeCanReplaceWithWildcards[p]=!1)}),a[e].count+=1):a[e]={count:1,elementsWhichWeCanReplaceWithWildcards:Array.from(u)}}}let s={};return Object.keys(a).forEach(c=>{let o=c;if(Array.isArray(a[c].elementsWhichWeCanReplaceWithWildcards)&&a[c].elementsWhichWeCanReplaceWithWildcards.some(u=>u!==!1)){let u=[],e=0;for(let l=0;l<a[c].elementsWhichWeCanReplaceWithWildcards.length;l++)e=o.indexOf(`${i.wildcard||""}`,e+(i.wildcard||"").length),a[c].elementsWhichWeCanReplaceWithWildcards[l]!==!1&&u.push([e,e+(i.wildcard||"").length,a[c].elementsWhichWeCanReplaceWithWildcards[l]]);o=E(o,u)}s[o]=a[c].count}),s}return F(B);})();
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 6.0.6
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 9.0.6
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */
/**
 * @name ranges-apply
 * @fileoverview Take an array of string index ranges, delete/replace the string according to them
 * @version 7.0.6
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-apply/}
 */
/**
 * @name codsen-utils
 * @fileoverview Various utility functions
 * @version 1.3.0
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/codsen-utils/}
 */
